#include <stdio.h>
#include <stdlib.h>
#include <arpa/inet.h>


char blacky_ver_info[] = "Demo SockMD5Auth v0.01 (c) Copyright 2002 Andreas Hofmeier";


main(argc, argv)
  int argc;
  char *argv[];
{
  int fd;
  char pwd[50];
  char cd[256];
  int forkpid = 0; 

  int sock;            /* listen on sock_fd, new connection on new_fd */
  struct sockaddr_in their_addr; /* connector's address information */
  int sin_size;

  // Server
  if (argc == 2) {
    printf("Waiting for a client...\n");
    sock = Bind(atoi(argv[1]), 10);
    sin_size = sizeof(struct sockaddr_in);
    fd = accept(sock, (struct sockaddr *)&their_addr, &sin_size);
  } else {
    // Client
    if (argc == 3) {
      fd = Socket(argv[1], atoi(argv[2]));
    } else {
      printf("Blacky MD5Auth Demo\n\n");
      printf("Server: bsmd5auth <localport>\n");
      printf("Client: bsmd5auth <server> <serverport>\n");
      exit(0);
    }
  }
  if (fd < 0) {
    exit(0);
  }
  printf("enter authstring (\"0\" - No Auth): ");
  gets(pwd);
  if (!((pwd[0] == '0') && (pwd[1] == 0))) {
    if (SockMD5Auth(fd, pwd) == 1) {
      printf("Auth: OK\n");
    } else {
      printf("Auth: Fail\n");
    }
  }
  if (forkpid = fork()) {
    while (1) {
      if (SockRecvString(fd, cd) < 0) {
	exit(0);
      }
      printf("> %s\n", cd);
    }
  }
  while (1) {
    gets(cd);
    SockSendString(fd, cd);
  }
}
